Codeforces 30C Shooting Gallery【dp】

C. Shooting Gallery
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

One warm and sunny day king Copa decided to visit the shooting gallery, located at the Central Park, and try to win the main prize — big pink plush panda. The king is not good at shooting, so he invited you to help him.

The shooting gallery is an infinite vertical plane with Cartesian coordinate system on it. The targets are points on this plane. Each target is described by it's coordinates xi, and yi, by the time of it's appearance ti and by the number pi, which gives the probability that Copa hits this target if he aims at it.

A target appears and disappears instantly, so Copa can hit the target only if at the moment ti his gun sight aimed at (xi, yi). Speed of movement of the gun sight on the plane is equal to 1. Copa knows all the information about the targets beforehand (remember, he is a king!). He wants to play in the optimal way, which maximizes the expected value of the amount of hit targets. He can aim at any target at the moment 0.

Input

The first line contains integer n (1 ≤ n ≤ 1000) — amount of targets in the shooting gallery. Then n lines follow, each describing one target. Each description consists of four numbers xi, yi, ti, pi (where xi, yi, ti — integers,  - 1000 ≤ xi, yi ≤ 1000, 0 ≤ ti ≤ 109, real number pi is given with no more than 6 digits after the decimal point, 0 ≤ pi ≤ 1). No two targets may be at the same point.

Output

Output the maximum expected value of the amount of targets that was shot by the king. Your answer will be accepted if it differs from the correct answer by not more than 10 - 6.

Examples
Input
1
0 0 0 0.5
Output
0.5000000000
Input
2
0 0 0 0.6
5 0 5 0.7
Output
1.3000000000

题目大意:

一共有N个点有靶子,初始的时候可以让枪放在任意位子,然后给你N个靶子的信息,包括其坐标,出现的时间,以及打中的分数.

问最多能够获得多少积分。枪每一单位时间移动的速度为1个坐标单位。


思路:


1、考虑这样一个问题:我们首先一定是先打掉一个先出现的靶子之后再打其他后出现靶子,那么我们此时不妨设定dp【i】【j】表示打完第i个靶子之后再打第j个靶子能够得到的最高分数,其状态转移方程也很好想:dp【i】【j】=max(dp【i】【j】,dp【k】【i】+val【j】);【1<=k<=n】暴力做法时间复杂度O(n^3);显然需要对其进行优化。


2、继续考虑这样一个问题:我们首先一定是打掉一个先出现的靶子之后再打其他后出现的靶子,那么其一定有一个时间顺序,那么此时我们不妨将所有靶子出现的时间按照升序排序,那么我们此时设定到第i个靶子在第j个靶子之后打掉,那么此时一定j<i,那么我们此时可以设定dp【i】,表示打第i个出现的靶子的时候能够获得的最高分数。那么此时状态转移方程:

dp【i】=max(dp【i】,dp【j】+val【i】)【0<=j<i&&打完j之后移动枪的时间是充足的】;

此时时间复杂度O(N^2)


Ac代码:


#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<math.h>
using namespace std;
struct node
{
    int x,y,t;
    double val;
}a[1515];
double dp[1515];
int cmp(node a,node b)
{
    return a.t<b.t;
}
int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        for(int i=0;i<n;i++)
        {
            scanf("%d%d%d%lf",&a[i].x,&a[i].y,&a[i].t,&a[i].val);
        }
        sort(a,a+n,cmp);
        memset(dp,0,sizeof(dp));
        for(int i=0;i<n;i++)
        {
            dp[i]=a[i].val;
            for(int j=0;j<i;j++)
            {
                long long int t1=(a[i].t-a[j].t);
                t1*=(a[i].t-a[j].t);
                long long int tmp1=(a[i].x-a[j].x);
                long long int tmp2=(a[i].y-a[j].y);
                long long int t2=tmp1*tmp1+tmp2*tmp2;
                if(t1>=t2)
                {
                    dp[i]=max(dp[i],dp[j]+a[i].val);
                }
            }
        }
        double output=0;
        for(int i=0;i<n;i++)
        {
            output=max(output,dp[i]);
        }
        printf("%lf\n",output);
    }
}






  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值